Summary: ffingerd - Fefe's small and secure finger daemon
Name: ffingerd
Version: 1.18
Release: 0 
Copyright: GPL
Group: Networking/Daemons
Source: ftp://ftp.fu-berlin.de/pub/unix/security/ffingerd/ffingerd-1.18.tar.gz
vendor: Felix von Leitner <leitner@math.fu-berlin.de>, <leitner@inf.fu-berlin.de>
distribution: RPM version by Serge Droz (droz@physics.uoguelph.ca) 1997
packager: Serge Droz (droz@physics.uoguelph.ca) 1997
%description
 A simple and pretty finger deamon that does only what you
 need. The cool features are: Does not run as root, does not 
 reveal much about the user (No last login, mail, shell, or 
 last login from), gives the user the choice of blocking
 fingers, has .plan, .project, and .pgpkey files, does not
 permit system fingers, does full logging and prevents certain 
 kinds of local user attacks. Finally someone gets it right!



%prep
%setup

%build
configure
make
%install
make install
cp ffingerd.8 /usr/local/man/man8/ffingerd.8
%post
# Go through /etc/services, removing comments, looking for the line with
# [whitespace]79/tcp.  Save that line into $id.  Fail if sed didn't like
# my code or had a non-zero exit code.
#
if id=`/bin/sed -n -e 's/#.*//' \
	     -e '/[ 	]79\/tcp/p' < /etc/services`; then
  if test g"$id" != g ; then
    echo Finger service found in /etc/services, identifier is \"$id\"
  else
    echo Finger service not found in /etc/services
    echo adding \"finger 79/tcp\" ...
    echo >> /etc/services
    echo "finger 79/tcp" >> /etc/services
    id="finger"
  fi
else
  echo "sed did not like my script :("
  echo "Consider installing GNU sed."
  exit 1
fi
#
# Now move /etc/inetd.conf to /etc/inetd.conf.backup. If that fails,
# bail out.  Otherwise run /bin/awk (/usr/bin/awk) with the environment
# variable BINARY=/usr/local/sbin/ffingerd (/usr/sbin/fingerd), feeding in the original
# inetd.conf file and writing the result to /etc/inetd.conf.  This awk
# script matches all lines with one of the aliases from the
# /etc/services finger entry we found, comments them out, and outputs
# a new line with our new finger daemon behind it.
#
if mv /etc/inetd.conf /etc/inetd.conf.backup; then
  /bin/gawk '$1 == "finger" {print "# "$0; print "finger stream tcp nowait nobody /usr/local/sbin/ffingerd fingerd";next} \
             {print $0}' /etc/inetd.conf.backup > /etc/inetd.conf
else
  echo "Sorry, could not edit /etc/inetd.conf";
  exit 1
fi

#
# Send inetd a hangup if we find the inetd.pid file
#
if test -f /etc/inetd.pid; then
  kill -1 `cat /etc/inetd.pid`
else
  if test -f /var/run/inetd.pid; then
    kill -1 `cat /var/run/inetd.pid`
  else
    if test -f /usr/etc/inetd.pid; then
      kill -1 `cat /usr/etc/inetd.pid`
    else
      if test `/bin/uname` = HP-UX; then
        /etc/inetd -c
      else
	if test /usr/bin/killall != none; then
	  /usr/bin/killall -1 inetd
	else
          echo "I could not locate inetd.pid, please kill -1 inetd yourself."
	fi
      fi
    fi
  fi
fi
%postun
mv -f /etc/inetd.conf /etc/inetd.conf.orig
/bin/awk '$1 != "finger" || $6 != "/usr/local/sbin/ffingerd" {print $0}' /etc/inetd.conf.orig > /etc/inetd.conf
#
# Send inetd a hangup if we find the inetd.pid file
#
if test -f /etc/inetd.pid; then
  kill -1 `cat /etc/inetd.pid`
else
  if test -f /var/run/inetd.pid; then
    kill -1 `cat /var/run/inetd.pid`
  else
    if test -f /usr/etc/inetd.pid; then
      kill -1 `cat /usr/etc/inetd.pid`
    else
      if test `/bin/uname` = HP-UX; then
        /etc/inetd -c
      else
	if test /usr/bin/killall != none; then
	  /usr/bin/killall -1 inetd
	else
          echo "I could not locate inetd.pid, please kill -1 inetd yourself."
	fi
      fi
    fi
  fi
fi
%files 
%doc NEWS
%doc README
%doc README
%doc TODO
%doc INSTALL
%doc COPYING
/usr/local/sbin/ffingerd
/usr/local/man/man8/ffingerd.8